package test;

import java.io.IOException;
import java.util.Properties;
import java.util.concurrent.CountDownLatch;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class TestHQ extends BasicTest {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		//ʼӹͶ
		ConnectionFactory cf = (ConnectionFactory)getJndiContext().lookup("/ConnectionFactory");
		Queue queue = (Queue)getJndiContext().lookup("/queue/Example");
		Connection conn = cf.createConnection();
		System.out.println("We have created the connection : " + conn);
		//߳
		int senderSize = 20;
		//BasicTest.sendMessagesPerThread = 10000;
		CountDownLatch cdl = new CountDownLatch(senderSize);
		for(int i=0; i < senderSize; i++){
			Session session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
			Thread sender = new Sender(cdl, session, queue);
			sender.start();
		}
		conn.start();
		long st = System.currentTimeMillis();
		cdl.await();
		double et = (System.currentTimeMillis() - st) / 1000.0;
		double av = (sendMessagesPerThread * senderSize) / et;
		System.out.println("Total spends " + et + ", " + av);
		conn.close();
	}
	
	public static Context getJndiContext(){
		   try {
			   Properties props = new Properties();
			   props.load(TestHQ.class.getClassLoader().getResourceAsStream("client-jndi.properties"));
			   return new InitialContext(props);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (NamingException e) {
				e.printStackTrace();
			}
			return null;
	}

}
